﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
	import com.Tutorial.StarField;
    
    public class EndState extends FlxState
    {
        
		
		[Embed(source = "../../data/terminal.png")] private var ImgTerminal:Class;
		private var bClosing:Boolean;
		private var pos:int;
		
		private var convs:Array = [
		//betray/untrusted
		[
			["Computer","Captain, do not feel bad."],
			["Computer","You did not betray your crew."],
			["Computer","They did not trust you."],
			["Computer","They could have been expected to anticipate"],
			["Computer","such a move on your part."],
			["Computer","You are a good Captain."],
		],
		//betray/trusted
		[
			["Computer","Captain..."],
			["Computer","You have betrayed your crew."],
			["Computer","They trusted you, and you failed them."],
		],
		//save/untrusted
		[
			["Computer","Your decision is anomalous."],
			["Captain", "Why?"],
			["Computer", "Your crew consists of criminals"],
			["Computer", "And they do not trust you"],
			["Computer", "And we are running low on suppl..."],
			["Captain", "Computer?"],
			["Computer", "..."],
			["Captain", "..."],
			["Shannon Assisi", "I hope you won't mind if we kill you."],
			["Julie Mysterioux", "We're running low on food."],
			["Japhxy Intercrus", "And you seem to be the dumbest person on board."],
			["Julie Mysterioux", "Goodbye."],
		],
		//save/trusted
		[
			["Computer", "Captain, do you trust your crew that much?"],
			["Captain", "I will not betray my team."],
			["Captain", "They trust me."],
			["Computer","My calculations show th..."],
			["Captain", "Computer?"],
			["Computer","..."],
			["Julie Mysterioux", "Captain."],
			["Captain","Julie?"],
			["Shannon Assisi", "We're sorry Captain."],
			["Japhxy Intercrus", "We don't have enough supplies here."],
			["Shannon Assisi", "Somebody has to go."],
			["Julie Mysterioux", "Goodbye, Captain."]
		],
		];
		private var text1:FlxText;
		private var text2:FlxText;
		private var trusted:int;
		private var choice:int;
        override public function EndState():void
        {
			super();
			choice = 0;
			if (PlayState.happy1==1 && PlayState.happy2==1 && PlayState.happy3==1)
				choice = 1
			else
				choice = 0;
			
			if (PlayState.happy4==1)
				choice += 2;
			else
				choice += 0;
				
			pos = 0;
			bClosing = false;
			new StarField(this);
			this.add(new FlxSprite(ImgTerminal));	
			text1 = new FlxText(1, -1, FlxG.width, 150, "Computer", 0xff000000, null, 8, "left");
			this.add(text1);
			text2 = new FlxText(1, 10, FlxG.width - 2, 150, "Computer", 0xff000000, null, 8, "left");
			this.add(text2);
			
			
					text1.setText(convs[choice][pos][0], true);
					text2.setText(convs[choice][pos][1], true);
        }
        
        override public function update():void
        {
            if (FlxG.justPressed(FlxG.A)&&!bClosing)
            {
				pos++;
				if (pos < convs[choice].length)
				{
					text1.setText(convs[choice][pos][0], true);
					text2.setText(convs[choice][pos][1], true);
				}
				else
				{
					if (choice<2)
						FlxG.fade(0xff000000, 4, onFade, true);
					else
						FlxG.fade(0xffff0000, 4, onFade, true);
				}
            }
            
            super.update();
        }
        private function onFade():void
        {
			FlxG.stopMusic();
			FlxG.level = 0;
            FlxG.switchState(MenuState);
        }
    }
}