﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
	import com.Tutorial.StarField;
	
    public class PlayState extends FlxState
    {
		[Embed(source = '../../data/tiles.png')] private var ImgTiles:Class;
		[Embed(source = '../../data/npcs.png')] private var ImgNPCs:Class;
        [Embed(source = '../../data/mainmap.txt', mimeType = "application/octet-stream")] private var DataMap:Class;
     
		[Embed(source="../../data/blip.mp3")] private var SndBlip:Class;
		
        private var _player:Player;
		private var _map:FlxTilemap;
		
        public static var lyrStage:FlxLayer;
        public static var lyrSprites:FlxLayer;
		
		public static var talkingto:DumbCrewMember;
		
		public static var _cm1:DumbCrewMember;
		public static var _cm2:DumbCrewMember;
		public static var _cm3:DumbCrewMember;
		public static var _port:Teleporter;
		public static var _text:FlxText;
		public static var _text2:FlxText;
		public static var _text3:FlxText;
		public static var _text4:FlxText;
		public static var _textb:FlxText;
		public static var _text2b:FlxText;
		public static var _text3b:FlxText;
		public static var _text4b:FlxText;
		public static var _speech:FlxText;
		public static var _speech2:FlxText;
		
		public var linenumber:int;
		
		public static var happy1:int = 0;
		public static var happy2:int = 0;
		public static var happy3:int = 0;
		public static var happy4:int = 0;
		
        public function PlayState():void
        {			
            super();
			FlxG.setMusic(MenuState.SndMusic3);
			
			linenumber = 0;
			
			interacting = false;
			leaving = false;
            lyrStage = new FlxLayer;
			lyrSprites = new FlxLayer;
			
            _player = new Player(24 * 8, 38 * 8);
			
			switch (FlxG.level)
			{
				case 8:
				case 7:
				case 6:
				case 5:
				case 4:
					_cm1 = new DumbCrewMember(23 * 8, 37 * 8, 3, _player);
					_cm1.happy = happy3;
				case 3:
				case 2:
					_cm3 = new DumbCrewMember(32 * 8, 26 * 8, 2,_player);
					_cm3.happy = happy2;
				case 1:
					_cm2 = new DumbCrewMember(24*8,27*8, 1,_player);
					_cm2.happy = happy1;
				case 0:
			}
			_port = new Teleporter(34 * 8+1, 33 * 8+2,_player);
			
			lyrSprites.add(_cm1);
			lyrSprites.add(_cm2);
			lyrSprites.add(_cm3);
			lyrSprites.add(_port);

											
            FlxG.follow(_player, 10);
            FlxG.followAdjust(0, 0);
            FlxG.followBounds(0,0,59*8,59*8);        
		
            _map = new FlxTilemap(new DataMap, ImgTiles, 5);
            lyrStage.add(_map);        
			
			
			//gross note stuff begin
			var widthInTiles:int = 0;
			var heightInTiles:int = 0;			
			
			//gross note stuff end
            lyrSprites.add(_player);
  			new StarField(this);

            this.add(lyrStage);
            this.add(lyrSprites);
			
			_textb = new FlxText(-1, 1, FlxG.width, 30, "press x to begin mission", 0xff000000, null,8, "left");
			_textb.visible = false;
			this.add(_textb);
			
			_text2b = new FlxText(-1, 1, FlxG.width, 30, "press x to talk to Japhyx", 0xff000000, null,8, "left");
			_text2b.visible = false;
			this.add(_text2b);
			
			_text3b = new FlxText(-1, 1, FlxG.width, 30, "press x to talk to Julie", 0xff000000, null,8, "left");
			_text3b.visible = false;
			this.add(_text3b);
			
			_text4b = new FlxText(-1, 1, FlxG.width, 30, "press x to talk to Shannon", 0xff000000, null,8, "left");
			_text4b.visible = false;
			this.add(_text4b);
			
			_text = new FlxText(0, 0, FlxG.width, 30, "press x to begin mission", 0xffffffff, null,8, "left");
			_text.visible = false;
			this.add(_text);
			
			_text2 = new FlxText(0, 0, FlxG.width, 30, "press x to talk to Japhyx", 0xffffffff, null,8, "left");
			_text2.visible = false;
			this.add(_text2);
			
			_text3 = new FlxText(0, 0, FlxG.width, 30, "press x to talk to Julie", 0xffffffff, null,8, "left");
			_text3.visible = false;
			this.add(_text3);
			
			_text4 = new FlxText(0, 0, FlxG.width, 30, "press x to talk to Shannon", 0xffffffff, null,8, "left");
			_text4.visible = false;
			this.add(_text4);
			
			_speech = new FlxText(0, 0, FlxG.width, 400, "waffle waffle", 0xffffffff, null, 8, "left");
			_speech.visible =false;
			_speech.setText("ago", true);
			_speech2 = new FlxText(-1, 1, FlxG.width, 400, "waffle waffle", 0xff000000, null, 8, "left");
			_speech2.visible =false;
			_speech2.setText("ago", true);
			this.add(_speech2);
			this.add(_speech);
        }
        
		private function cando():int
		{
			var nResult:int = 0;
			switch (_player.dir)
				{
					case 0:
						_player.y -= 8;
					break;
					case 1:
						_player.y += 8;
					break;
					case 2:
						_player.x -= 8;
					break;
					case 3:
						_player.x += 8;
					break;
				}

			
				
				switch (_player.dir)
				{
					case 0:
						_player.y += 8;
					break;
					case 1:
						_player.y -= 8;
					break;
					case 2:
						_player.x += 8;
					break;
					case 3:
						_player.x -= 8;
					break;
				}
				return nResult;
		}
		

		public function randomNumber(low:int, high:int):int
		{
		  return Math.round(Math.random() * (high - low)) + low;
		}
		
		public function startMission():void
		{
			FlxG.switchState(PreludeState);
		}
		
		public static var interacting:Boolean;
		public static var leaving:Boolean;
		
        override public function update():void
        {					
			if (interacting)
			{
				if (!leaving && FlxG.justPressed(FlxG.A))
				{
					linenumber++;
					var s:String = talkingto.getLine(linenumber);
					if (s=="")
						interacting = false;
					else
					{
						_speech.setText(s);
						_speech2.setText(s);
					}
				}
				return;
			}
            super.update();
            _map.collide(_player);
			if (_cm1)
				_cm1.collide(_player);
			if (_cm2)
				_cm2.collide(_player);
			if (_cm3)
				_cm3.collide(_player);
			
			_text.visible = false;
			_text2.visible = false;
			_text3.visible = false;
			_text4.visible = false;
			_textb.visible = false;
			_text2b.visible = false;
			_text3b.visible = false;
			_text4b.visible = false;
			_speech.visible = false;
			_speech2.visible = false;
			
			if (_port.dist(_player) < 10)
			{
				if (FlxG.justPressed(FlxG.A)&&!interacting)
				{
					interacting = true;
					leaving = true;
					FlxG.fade(0xff000000, 1, startMission, true);
					FlxG.play(MenuState.SndOpen);
				}
				_text.visible = true;
			}
			else if (_cm1 && _cm1.dist(_player) < 10)
			{
				if (FlxG.justPressed(FlxG.A)&&!interacting)
				{
					interacting = true;
					linenumber = 0;
					talkingto = _cm1;
					_speech.setText(_cm1.getLine(linenumber));
					_speech.visible = true;
					_speech2.setText(_cm1.getLine(linenumber));
					_speech2.visible = true;
				}
				else
				{
					_text2.visible = true;				
					_text2b.visible = true;				
				}
			}
			else if (_cm2 && _cm2.dist(_player) < 10)
			{
				if (FlxG.justPressed(FlxG.A)&&!interacting)
				{
					interacting = true;
					linenumber = 0;
					talkingto = _cm2;
					_speech.setText(_cm2.getLine(linenumber));
					_speech.visible = true;
					_speech2.setText(_cm2.getLine(linenumber));
					_speech2.visible = true;
				}
				else
				{
					_text3.visible = true;				
					_text3b.visible = true;				
				}			
			}
			else if (_cm3 && _cm3.dist(_player) < 10)
			{
				if (FlxG.justPressed(FlxG.A)&&!interacting)
				{
					interacting = true;
					linenumber = 0;
					talkingto = _cm3;
					_speech.setText(_cm3.getLine(linenumber));
					_speech.visible = true;
					_speech2.setText(_cm3.getLine(linenumber));
					_speech2.visible = true;
				}
				else
				{
					_text4.visible = true;				
					_text4b.visible = true;				
				}				
			}
			else
			{

			}
			
			
			
			
		    //FlxG.overlapArray(_k, _p, KeyHit);
		    //FlxG.overlapArray(_d, _p, DoorHit);
		}		
		
    }    
}