﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
    
    public class Ship extends FlxSprite
    {
        [Embed(source='../../data/ship.png')] private var ImgPlayer:Class;
        
        private var _move_speed:int = 500;
        private var _jump_power:int = 800;   
        private var _max_health:int = 10;
        private var _hurt_counter:Number = 0;
		public var myhealth:int;
		
        public function Ship(X:Number,Y:Number,starhealth:int):void
        {
            super(ImgPlayer, X, Y, true, false, 8, 9);//Max speeds
			
			if (FlxG.level >= 2)
			{
				if (PlayState.happy2)
				{
					myhealth = 3;
				}
				else
				{
					myhealth = 2;
				}
			}
			else
			{
				myhealth = 0;
			}
			
            maxVelocity.x = 50;
            maxVelocity.y = 50;
            //Gravity
            acceleration.y = 0;            
            //Friction
            drag.x = 90;
            drag.y = 90;
            //bounding box tweaks
            width = 6;
            height = 5;
            offset.x = 0;
            offset.y = 2;
			height = 5;
			width = 6;
			addAnimation("0", [0]);
            addAnimation("1", [1]);
            addAnimation("2", [2]);
            addAnimation("3", [3]);
			play(myhealth.toString() );		
        }
    
		public function setHealth(h:int):void
		{
			myhealth = h;
			play(myhealth.toString());
		}
        override public function update():void
        {
            if(dead)
            {
                if(finished) exists = false;
                else
                    super.update();
                return;
            }
			acceleration.x = 0;
			acceleration.y = 0;
            
			if (this.myhealth < 0)
			{
				velocity.x = 0;
				velocity.y = 0;
				super.update();
				return;
			}
			
			if(FlxG.kLeft)
            {
                acceleration.x = -_move_speed;
            }
            if (FlxG.kRight)
            {
                acceleration.x = _move_speed;  
            }
			if (FlxG.kUp)
			{
				acceleration.y = -_move_speed;
			}
			if (FlxG.kDown)
			{
				acceleration.y = _move_speed;
			}
			            super.update();

			
			if (x < 0)
			{
				x = 0;
				velocity.x = 0;
				acceleration.x = 0;
			}
			else if (x+width > FlxG.width)
			{
				x = FlxG.width - width;
				velocity.x = 0;
				acceleration.x = 0;
			}
			
			if (y < 0)
			{
				y = 0;
				velocity.y = 0;
				acceleration.y = 0;
			}
			else if (y+height > FlxG.height)
			{
				y = FlxG.height - height;
				velocity.y = 0;
				acceleration.y = 0;
			}
			
        }

        override public function hurt(Damage:Number):void
        {
            _hurt_counter = 1;
            return super.hurt(Damage);
        }       
    }
}