﻿package com.Tutorial
{
    import com.adamatomic.flixel.*;
	import com.Tutorial.StarField;
	
    public class ShipState extends FlxState
    {
        [Embed(source = '../../data/mainmap.txt', mimeType = "application/octet-stream")] private var DataMap:Class;
		
		[Embed(source = "../../data/laser.mp3")] public static var SndLaser:Class;
		[Embed(source = "../../data/missile.mp3")] public static var SndMissile:Class;
		[Embed(source = "../../data/boom2.mp3")] public static var SndBoom:Class;
		[Embed(source = "../../data/sheilddown.mp3")] public static var SndShield:Class;
		
        private var _ship:Ship;
		
        public static var lyrStage:FlxLayer;
        public static var lyrSprites:FlxLayer;
		public static var arrEntities:FlxArray;
		private static var counter:Number;
		private static var _pewpew:FlxSprite;
		private static var _pewpewtimer:Number;
		private static var _rocket1:FlxSprite;
		private static var _rocket2:FlxSprite;
		private static var _rockettimer:Number;
		private static var _time:Number;
		private static var _timeint:Number;
		private static var _timelbl:FlxText;
		private var dying:Boolean;
		
        public function ShipState():void
        {			
			dying = false;
			arrEntities = new FlxArray();
						FlxG.setMusic(MenuState.SndMusic1);
            super();
			
			
			_time = 30;
			_timeint = 30;
			_timelbl = new FlxText(1, 1, 100, 8, _time.toString(), 0xff000000, null, 8);
			this.add(_timelbl);
			
			new StarField(this);
            lyrStage = new FlxLayer;
			lyrSprites = new FlxLayer;

            _ship = new Ship(40,FlxG.height/2-3,3);
			_pewpewtimer = 0.4;
			_rockettimer = 0.4;
			_pewpew = new FlxSprite(null, FlxG.width, 0, false, false, 4, 1, 0xffdfe076);
			_pewpew.velocity.x = 80;
			_rocket1 = new FlxSprite(null, FlxG.width, 0, false, false, 4, 1, 0xffdfe076);
			_rocket1.velocity.x = 30;
			_rocket1.velocity.y = 30;
			_rocket2 = new FlxSprite(null, FlxG.width, 0, false, false, 4, 1, 0xffdfe076);
			_rocket2.velocity.x = 30;
			_rocket2.velocity.y = -30;
			lyrSprites.add(_pewpew);
			lyrSprites.add(_rocket1);
			lyrSprites.add(_rocket2);
								
			//gross note stuff end
            lyrSprites.add(_ship);
  			new StarField(this);

            this.add(lyrStage);
            this.add(lyrSprites);

			counter = Math.random();
			_pewpewtimer = Math.random();
			_rockettimer = Math.random();
		}

		public function randomNumber(low:int, high:int):int
		{
		  return Math.round(Math.random() * (high - low)) + low;
		}
		
	
        override public function update():void
        {				
			_time-= FlxG.elapsed;
			if (_timeint != Math.floor(_time))
			{
				_timeint = Math.floor(_time);
				_timelbl.setText(_timeint.toString());
				if (_timeint < 5)
					FlxG.play(MenuState.SndOpen);
				
				if (_timeint == -1 && !dying)
				{
					FlxG.switchState(PostludeState);
				}
			}
			
			_pewpew.update();

			counter += FlxG.elapsed;
			if (counter > 0.10+0.50*(6-FlxG.level)/6)
			{
				counter = 0;
				var r:Rock = new Rock(FlxG.width, Math.random() * (FlxG.height-4));
				this.add(r);
				arrEntities.push(r);
			}
			
			
			if (FlxG.level >= 1)
			{
				if (PlayState.happy1)
				{
					_pewpewtimer += FlxG.elapsed;
				}
				else
				{
					_pewpewtimer += FlxG.elapsed/2;
				}
				
				if (_pewpewtimer > 1)
				{
					FlxG.play(SndLaser,0.5);
					_pewpewtimer = 0;
					_pewpew.x = _ship.x + _ship.width;
					_pewpew.y = _ship.y+2;
				}
			}
			

			
			if (FlxG.level >= 4)
			{
				if (PlayState.happy3)
				{
					_rockettimer += FlxG.elapsed;
				}
				else
				{
					_rockettimer += FlxG.elapsed/2;
				}
				
				if (_rockettimer > 1)
				{
					FlxG.play(SndMissile,0.5);
					_rockettimer = 0;
					_rocket1.x = _ship.x + _ship.width-1;
					_rocket1.y = _ship.y;
					_rocket2.x = _ship.x + _ship.width-1;
					_rocket2.y = _ship.y+4;
				}
			}
			
			for (var i:int = arrEntities.length-1; i>=0; i--)
			{
				var r2:Rock = arrEntities[i] as Rock;
				if (r2.dead)
					arrEntities.splice(i, 1);
			}
			FlxG.overlapArray(arrEntities, _ship, blah);
			FlxG.overlapArray(arrEntities, _pewpew, blah2);
			FlxG.overlapArray(arrEntities, _rocket1, blah2);
			FlxG.overlapArray(arrEntities, _rocket2, blah2);
            super.update();
		    //FlxG.overlapArray(_k, _p, KeyHit);
		    //FlxG.overlapArray(_d, _p, DoorHit);
		}		
		
		private function blah(a:FlxSprite, b:FlxSprite):void
		{
			var s:Ship = b as Ship;
			if (s.myhealth >= 0 && !s.flickering())
			{
				a.kill();
				s.setHealth(s.myhealth-1);
				if (s.myhealth < 0)
				{
					FlxG.play(SndShield,(4-s.myhealth)*2);
					s.flicker(2);
					dying = true;
					FlxG.fade(0xff000000, 0.5, sceneDead, true);
				}
				else
				{
					s.flicker(2);
					FlxG.play(SndShield,(4-s.myhealth)*2);
				}
			}
		}
		
		private function sceneDead():void
		{
				FlxG.switchState(DeadState);
		}
		
		private function blah2(a:FlxSprite, b:FlxSprite):void
		{
			b.y = FlxG.width + 20;
			a.kill();
			FlxG.play(SndBoom,1);
		}
    }    
}